import 'dart:async';

import 'package:shared_preferences/shared_preferences.dart';

const String _storageKey = "TokenFCM_";

Future<SharedPreferences> _prefs = SharedPreferences.getInstance();

TokenFMCPreferences tokenFireBaseReferences = TokenFMCPreferences();

class TokenFMCPreferences {
  /// ----------------------------------------------------------
  /// Generic routine to fetch a preference
  /// ----------------------------------------------------------
  Future<String> _getStringApplicationSavedInformation(String name) async {
    final SharedPreferences prefs = await _prefs;

    return prefs.getString(_storageKey + name) ?? '';
  }

  Future<String> getPreferredTokenFCM() async {
    return _getStringApplicationSavedInformation('tokenFCM');
  }

  Future<bool> _setStringApplicationSavedInformation(
      String name, String value) async {
    final SharedPreferences prefs = await _prefs;

    return prefs.setString(_storageKey + name, value);
  }

  ///set token Firebase messaging cloud cho user
  Future<bool> setPreferredTokenFMC(String tokenFMC) async {
    return _setStringApplicationSavedInformation('tokenFCM', tokenFMC);
  }

  // ------------------ SINGLETON -----------------------
  static final TokenFMCPreferences _preferences =
      TokenFMCPreferences._internal();

  factory TokenFMCPreferences() {
    return _preferences;
  }

  TokenFMCPreferences._internal();
}
