import 'package:flutter/widgets.dart';

class ScreenConfig {
  ScreenConfig._();

  static MediaQueryData _mediaQueryData;
  static double screenWidth;
  static double screenHeight;
  static double blockSizeHorizontal;
  static double blockSizeVertical;

  static double _safeAreaHorizontal;
  static double _safeAreaVertical;
  static double safeBlockHorizontal;
  static double safeBlockVertical;

  static void init(BuildContext context) {
    _mediaQueryData = MediaQuery.of(context);
    screenWidth = _mediaQueryData.size.width;
    screenHeight = _mediaQueryData.size.height;
    blockSizeHorizontal = screenWidth / 100;
    blockSizeVertical = screenHeight / 100;

    _safeAreaHorizontal =
        _mediaQueryData.padding.left + _mediaQueryData.padding.right;
    _safeAreaVertical =
        _mediaQueryData.padding.top + _mediaQueryData.padding.bottom;
    safeBlockHorizontal = (screenWidth - _safeAreaHorizontal) / 100;
    safeBlockVertical = (screenHeight - _safeAreaVertical) / 100;
  }

  //tính toán dự trên 7<x>7
  static bool isBigScreen() {
    return blockSizeVertical > 7 ? false : true;
  }

  static double wp(percentage) {
    return percentage / 100 * screenWidth;
  }

  static double hp(percentage) {
    return percentage / 100 * screenHeight;
  }

  static double getWidthPx(int pixels) {
    return (pixels / 3.61) / 100 * screenWidth;
  }
}
